<code>
#!/bin/bash
# go-photoframe.sh for Mk2 PhotoFrame, last updated 2016 Sept 28
# test if ImageMagick convert exists, and if not get it now
hash convert # check for convert (status appears on screen)
if [ $? -eq 1 ]; then
	# convert not found, install it now
    echo >&2 "convert not found, installing ImageMagick"
	sudo apt-get install -y imagemagick
fi
#
# Launch background tasks
# get and resize (comment this out if you don't need Pi to update /photos from USB etc)
sudo /photos/get-photos.sh &
# select next for display
sudo /photos/set-photo.sh &
# give the set-photo (background) script a chance to copy the first image into buffer1.jpg and alias link it to display.jpg
sleep 5
# now generate the 3 fbi files and alias them to the display file, which is itself an alias to one of the buffer files
# (-f means overwrite any existing link of the same name)
ln -s -f display.jpg alias-1.jpg
ln -s -f display.jpg alias-2.jpg
ln -s -f display.jpg alias-3.jpg
#
# launch fbi foreground task on a 3 second cycle
fbi -T 1 -d /dev/fb0 -noverbose -t 3 -cachemem 0 alias-1.jpg alias-2.jpg alias-3.jpg
